=encoding utf8

=head1 NAME

Mail::Message::Field::Attribute - one attribute of a full field

=head1 INHERITANCE

 Mail::Message::Field::Attribute
   is a Mail::Reporter

=head1 SYNOPSIS

  my $field    = $msg->head->get('Content-Disposition') or return;
  my $full     = $field->study;   # full understanding in unicode
  my $filename = $full->attribute('filename')           or return;

  print ref $filename;     # this class name
  print $filename;         # the attributes content in utf-8
  print $filename->value;  # same
  print $filename->string; # print string as was found in the file
  $filename->print(\*OUT); # print as was found in the file

=head1 DESCRIPTION

Attributes within MIME fields can be quite complex, and therefore be slow
and consumes a lot of memory.  The L<Mail::Message::Field::Fast|Mail::Message::Field::Fast> and
L<Mail::Message::Field::Flex|Mail::Message::Field::Flex> simplify them the attributes a lot, which
may result in erroneous behavior in rare cases.  With the increase of
non-western languages on Internet, the need for the complex headers
becomes more and more in demand.

A C<Mail::Message::Field::Attribute> can be found in any structured
L<Mail::Message::Field::Full|Mail::Message::Field::Full> header field.

Extends L<"DESCRIPTION" in Mail::Reporter|Mail::Reporter/"DESCRIPTION">.

=head1 OVERLOADED

=over 4

=item overload: B<""> stringification

Returns the decoded content of the attribute.

=item overload: B<cmp> string comparison

When the second argument is a field, then both attribute name (case-sensitive)
and the decoded value must be the same.  Otherwise, the value is compared.

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Reporter|Mail::Reporter/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Reporter|Mail::Reporter/"Constructors">.

=over 4

=item $class-E<gt>B<new>( <$name, [$value] | STRING>, %options )

Create a new attribute C<$name> with the optional C<$value>.  If no C<$value> is specified,
the first argument of this method is inspected for an equals sign C<'='>.
If that character is present, the argument is taken as C<STRING>, containing
a preformatted attribute which is processed.  Otherwise, the argument is
taken as name without C<$value>: set the value later with value().

Whether encoding takes place depends on the C<%options> and the existence
of non-ascii characters in the C<$value>.  The C<$name> can only contain ascii
characters, hence is never encoded.

To speed things up, attributes are not derived from the L<Mail::Reporter|Mail::Reporter>
base-class.
Improves base, see L<Mail::Reporter/"Constructors">

 -Option           --Default
  charset            'us-ascii'
  language           undef
  use_continuations  <C<true>>

=over 2

=item charset => STRING

The C<$value> is translated from utf-8 (Perl internal) to this character set,
and the resulting string is encoded if required.  C<us-ascii> is the normal
encoding for e-mail.  Valid character sets can be found with
C<Encode::encodings(':all')>.

=item language => STRING

RFC2231 adds the possibility to specify a language with the field.  When no
language is specified, none is included in the encoding.  Valid language
names are defined by RFC2130.  This module has only limited support for
this feature.

=item use_continuations => BOOLEAN

Continuations are used to break-up long parameters into pieces which
are no longer than 76 characters. Encodings are specified in RFC2231,
but not supported by some Mail User Agents.

=back

» example: 

  my $fn    = Mail::Message::Field::Attribute->new(filename => 'xyz');

  my $fattr = 'Mail::Message::Field::Attribute';  # abbrev
  my $fn    = $fattr->new(
    filename => "Re\xC7u",
    charset  => 'iso-8859-15',
    language => 'nl-BE'
  );
  print $fn;
    # -->  filename*=iso-8859-15'nl-BE'Re%C7u

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Reporter|Mail::Reporter/"Attributes">.

=head2 Error handling

Extends L<"Error handling" in Mail::Reporter|Mail::Reporter/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Reporter|Mail::Reporter/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head2 The attribute

=over 4

=item $obj-E<gt>B<addComponent>(STRING)

A component is a parameter as defined by RFC2045, optionally using
encoding or continuations as defined by RFC2231.  Components of an
attribute are found when a field is being parsed.  The RFCs are
very strict on valid characters, but we cannot be: you have to accept
what is coming in if you can.

» example: 

  my $param = Mail::Message::Field::Attribute->new;
  $param->addComponent("filename*=iso10646'nl-BE'%Re\47u");

=item $obj-E<gt>B<charset>()

Returns the character set which is used for this parameter.  If any component
is added which contains character set information, this is directly
available.  Be warned that a character-set is case insensitive.

=item $obj-E<gt>B<language>()

Returns the language which is defined in the argument.  If no language is
defined C<undef> is returned, which should be interpreted as "ANY"

=item $obj-E<gt>B<name>()

Returns the name of this attribute.

=item $obj-E<gt>B<string>()

When called in LIST context, the lines are returned to be post-processed
one after the other.  In SCALAR context, this returns the formatted
attribute list.

=item $obj-E<gt>B<value>( [STRING] )

Returns the value of this parameter, optionally after setting it first.

=back

=head2 Attribute encoding

=over 4

=item $obj-E<gt>B<decode>()

Translate all known continuations into a value.  The produced value is
returned and may be utf-8 encoded or a plain string.

=item $obj-E<gt>B<encode>()

Z<>

=back

=head2 Internals

=over 4

=item $obj-E<gt>B<mergeComponent>($attribute)

Merge the components from the specified attribute into this attribute.  This
is needed when components of the same attribute are created separately.
Merging is required by the field parsing.

=back

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Warning: illegal character in parameter name '$name'.

The specified parameter name contains characters which are not permitted by
the RFCs.  You can better change the name into something which is accepted,
or risk applications to corrupt or ignore the message.
Cast by C<new()>

=item Error: too late to merge: value already changed.

Cast by C<mergeComponent()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.05,
built on April 10, 2026. Website: F<http://perl.overmeer.net/mailbox/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

